// FileWriter.cpp: CFileWriter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsSelectDump.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CTsSelectDump::CTsSelectDump()
	: IMediaDecoder()
	, drop(0)
	, scrambling(0)
	, lastdrop(0)
	, lastscrambling(0)
	, lastTime(0)
	, biterror(0)
	, lastbiterror(0)
{
	for(int i=0;i<8192;i++){
		stat[i].pid = i;
		stat[i].last_continuity_counter = -1;
	}
	dumpList.clear();
	m_szRetryCmdLine[0] = 0x00;
	m_dropCount = 0;
	m_endTime = 0;
	onesecDrop = 0;
}

CTsSelectDump::~CTsSelectDump()
{
}

void CTsSelectDump::Reset(void)
{
}

void CTsSelectDump::SetDropRetry(int dropCount,char* szCmdLine,time_t endTime)
{
	m_dropCount = dropCount;
	strcpy(m_szRetryCmdLine,szCmdLine);
	m_endTime = endTime;
}

const DWORD CTsSelectDump::GetInputNum(void) const
{
	return 1;
}

const DWORD CTsSelectDump::GetOutputNum(void) const
{
	return 1;
}

const bool CTsSelectDump::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	TS_HEADER  header;
	ADAPTATION_FIELD adapt;

	unsigned char *curr = pMediaData->GetData();
	extract_ts_header(&header, curr);
	if(header.adaptation_field_control & 2){
		extract_adaptation_field(&adapt, curr+4);
	}else{
		memset(&adapt, 0, sizeof(adapt));
	}
	
	int m;
	int pid = header.pid;
	int lcc = stat[pid].last_continuity_counter;
	if( (lcc >= 0) && (adapt.discontinuity_counter == 0) ){
		if( pid == 0x1fff ){
			// null packet - drop count has no mean
			// do nothing
		}else if( (header.adaptation_field_control & 0x01) == 0 ){
			// no payload : continuity_counter should not increment
			if(lcc != header.continuity_counter){
				stat[pid].drop += 1;
				drop += 1;
				spotdrop += 1;
				onesecDrop += 1;
			}
		}else if(lcc == header.continuity_counter){
			// has payload and same continuity_counter
			if(memcmp(stat[pid].last_packet, curr, 188) != 0){
				// non-duplicate packet
				stat[pid].drop += 1;
				drop += 1;
				spotdrop += 1;
				onesecDrop += 1;
			}
			stat[pid].duplicate_count += 1;
			if(stat[pid].duplicate_count > 1){
				// duplicate packet count exceeds limit (two)
				stat[pid].drop += 1;
				drop += 1;
				spotdrop += 1;
				onesecDrop += 1;
			}
		}else{
			m = (lcc + 1) & 0x0f;
			if(m != header.continuity_counter){
				stat[pid].drop += 1;
				drop += 1;
				spotdrop += 1;
				onesecDrop += 1;
			}
			stat[pid].duplicate_count = 0;
		}
	}
	stat[pid].last_continuity_counter = header.continuity_counter;
	stat[pid].total += 1;
	memcpy(stat[pid].last_packet, curr, 188);
	if(header.transport_scrambling_control){
		stat[pid].scrambling += 1;
		scrambling += 1;
		spotscrambling += 1;
	}
	if(header.transport_error_indicator) {
		stat[pid].biterror += 1;
		biterror += 1;
		spotbiterror += 1;
	}

	BOOL bNew = FALSE;

	if(dumpList.size() > 0) {
		vector<DUMP_DATA>::reference lastdata = dumpList.back();
		if(lastdata.drop != spotdrop || lastdata.scrambling != spotscrambling || lastdata.biterror != spotbiterror) {
			if(lastdata.etime + 60 > time(NULL) /*&& lastdata.stime + 60*10 > time(NULL)*/) {
				lastdata.drop = spotdrop;
				lastdata.scrambling = spotscrambling;
				lastdata.biterror = spotbiterror;
				lastdata.etime = time(NULL);
			}
			else {
				spotdrop -= lastdata.drop;
				spotscrambling -= lastdata.scrambling;
				spotbiterror -= lastdata.biterror;
				bNew = TRUE;
			}
		}
	}
	else
		bNew = TRUE;

	if(bNew && (spotdrop > 0 || spotscrambling > 0 || spotbiterror > 0)) {
		DUMP_DATA dumpdata;
		dumpdata.drop = spotdrop;
		dumpdata.scrambling = spotscrambling;
		dumpdata.biterror = spotbiterror;
		dumpdata.stime = time(NULL);
		dumpdata.etime = dumpdata.stime;
		dumpList.push_back(dumpdata);
	}

	if(lastTime != time(NULL)) {
		lastTime = time(NULL);
		if(lastdrop != drop || lastscrambling != scrambling || lastbiterror != biterror) {
			lastdrop = drop;
			lastscrambling = scrambling;
			lastbiterror = biterror;
			struct tm* etm = localtime(&lastTime);
			TRACE("\r%02d:%02d:%02d drop=%3I64d, scrambling=%I64d, biterror=%I64d",etm->tm_hour,etm->tm_min,etm->tm_sec,drop,scrambling,biterror);
		}
		if(m_dropCount > 0 && onesecDrop > m_dropCount) {
			time_t nowt = time(NULL);
			char szNewTime[10];
			if(nowt < m_endTime) {
				PROCESS_INFORMATION pi;
				STARTUPINFO si;
				ZeroMemory(&si,sizeof(si));
				si.cb=sizeof(si);
				wsprintf(szNewTime," %d",((m_endTime-nowt)/60)+1);
				strcat(m_szRetryCmdLine,szNewTime);
				TRACE("\n%d ̃hbv܂̂%s wōċNs܂B\n",onesecDrop,szNewTime);
				CreateProcess(NULL,(LPTSTR)m_szRetryCmdLine,NULL,NULL,FALSE,CREATE_NEW_CONSOLE|NORMAL_PRIORITY_CLASS,NULL,NULL,&si,&pi);
				CloseHandle(pi.hThread);
				CloseHandle(pi.hProcess);
			}
		}
		onesecDrop = 0;
	}

	OutputMedia(pMediaData);
	
	return true;
}

__int64 CTsSelectDump::GetTotal(int pid)
{
	if(pid >= 0 && pid < 8192)
		return stat[pid].total;
	return 0;
}
__int64 CTsSelectDump::GetDrop(int pid)
{
	if(pid >= 0 && pid < 8192)
		return stat[pid].drop;
	return 0;
}
__int64 CTsSelectDump::GetScrambling(int pid)
{
	if(pid >= 0 && pid < 8192)
		return stat[pid].scrambling;
	return 0;
}
__int64 CTsSelectDump::GetBiterror(int pid)
{
	if(pid >= 0 && pid < 8192)
		return stat[pid].biterror;
	return 0;
}

int CTsSelectDump::GetDumpCount()
{
	return dumpList.size();
}
time_t CTsSelectDump::GetDumpSTime(int cnt)
{
	return dumpList[cnt].stime;
}
time_t CTsSelectDump::GetDumpETime(int cnt)
{
	return dumpList[cnt].etime;
}
__int64 CTsSelectDump::GetDumpDrop(int cnt)
{
	return dumpList[cnt].drop;
}
__int64 CTsSelectDump::GetDumpScrambling(int cnt)
{
	return dumpList[cnt].scrambling;
}
__int64 CTsSelectDump::GetDumpBiterror(int cnt)
{
	return dumpList[cnt].biterror;
}

void CTsSelectDump::extract_ts_header(TS_HEADER *dst, unsigned char *packet)
{
	dst->sync                         =  packet[0];
	dst->transport_error_indicator    = (packet[1] >> 7) & 0x01;
	dst->payload_unit_start_indicator = (packet[1] >> 6) & 0x01;
	dst->transport_priority           = (packet[1] >> 5) & 0x01;
	dst->pid = ((packet[1] & 0x1f) << 8) | packet[2];
	dst->transport_scrambling_control = (packet[3] >> 6) & 0x03;
	dst->adaptation_field_control     = (packet[3] >> 4) & 0x03;
	dst->continuity_counter           =  packet[3]       & 0x0f;
}

void CTsSelectDump::extract_adaptation_field(ADAPTATION_FIELD *dst, unsigned char *data)
{
	int n;
	unsigned char *p;
	unsigned char *tail;

	p = data;
	
	memset(dst, 0, sizeof(ADAPTATION_FIELD));
	if( (p[0] == 0) || (p[0] > 183) ){
		return;
	}

	dst->adaptation_field_length = p[0];
	p += 1;
	tail = p + dst->adaptation_field_length;
	if( (p+1) > tail ){
		memset(dst, 0, sizeof(ADAPTATION_FIELD));
		return;
	}

	dst->discontinuity_counter = (p[0] >> 7) & 1;
	dst->random_access_indicator = (p[0] >> 6) & 1;
	dst->elementary_stream_priority_indicator = (p[0] >> 5) & 1;
	dst->pcr_flag = (p[0] >> 4) & 1;
	dst->opcr_flag = (p[0] >> 3) & 1;
	dst->splicing_point_flag = (p[0] >> 2) & 1;
	dst->transport_private_data_flag = (p[0] >> 1) & 1;
	dst->adaptation_field_extension_flag = p[0] & 1;
	
	p += 1;
	
	if(dst->pcr_flag != 0){
		if( (p+6) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		dst->program_clock_reference = ((p[0]<<24)|(p[1]<<16)|(p[2]<<8)|p[3]);
		dst->program_clock_reference <<= 10;
		dst->program_clock_reference |= (((p[4]&0x80)<<2)|((p[4]&1)<<1)|p[5]);
		p += 6;
	}

	if(dst->opcr_flag != 0){
		if( (p+6) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		dst->original_program_clock_reference = ((p[0]<<24)|(p[1]<<16)|(p[2]<<8)|p[3]);
		dst->original_program_clock_reference <<= 10;
		dst->original_program_clock_reference |= (((p[4]&0x80)<<2)|((p[4]&1)<<1)|p[5]);
		p += 6;
	}

	if(dst->splicing_point_flag != 0){
		if( (p+1) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		dst->splice_countdown = p[0];
		p += 1;
	}

	if(dst->transport_private_data_flag != 0){
		if( (p+1) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		n = p[0];
		dst->transport_private_data_length = n;
		p += (1+n);
		if( p > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
	}

	if(dst->adaptation_field_extension_flag != 0){
		if( (p+2) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		n = p[0];
		dst->adaptation_field_extension_length = n;
		p += 1;
		if( (p+n) > tail ){
			memset(dst, 0, sizeof(ADAPTATION_FIELD));
			return;
		}
		dst->ltw_flag = (p[0] >> 7) & 1;
		dst->piecewise_rate_flag = (p[0] >> 6) & 1;
		dst->seamless_splice_flag = (p[0] >> 5) & 1;
		p += 1;
		n -= 1;
		if(dst->ltw_flag != 0){
			if(n < 2){
				memset(dst, 0, sizeof(ADAPTATION_FIELD));
				return;
			}
			dst->ltw_valid_flag = (p[0] >> 7) & 1;
			dst->ltw_offset = (((p[0] & 0x7f)<<8) | p[1]);
			p += 2;
			n -= 2;
		}
		if(dst->piecewise_rate_flag != 0){
			if(n < 3){
				memset(dst, 0, sizeof(ADAPTATION_FIELD));
				return;
			}
			dst->piecewise_rate = (((p[0] & 0x3f)<<16)|(p[1]<<8)|p[2]);
			p += 3;
			n -= 3;
		}
		if(dst->seamless_splice_flag != 0){
			if(n < 5){
				memset(dst, 0, sizeof(ADAPTATION_FIELD));
				return;
			}
			dst->splice_type = (p[0] >> 4) & 0x0f;
			dst->dts_next_au = (((p[0]&0x0e)<<14)|(p[1]<<7)|((p[2]>>1)&0x7f));
			dst->dts_next_au <<= 15;
			dst->dts_next_au |= ((p[3]<<7)|((p[4]>>1)&0x7f));
			p += 5;
			n -= 5;
		}
		p += n;
	}

}

